using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Serilog;
using Microsoft.Extensions.Configuration;

namespace ProjectLainer
{
    internal static class Program
    {
        [STAThread]
        static void Main()
        {
            ApplicationConfiguration.Initialize();
            var services = new ServiceCollection();
            ConfigureServices(services);
            using (ServiceProvider serviceProvider = services.BuildServiceProvider())
            {
                Application.Run(serviceProvider.GetRequiredService<FormLainerCollection>());
            }
        }
        private static void ConfigureServices(ServiceCollection services)
        {
            string[] path = Directory.GetCurrentDirectory().Split('\\');
            string pathNeed = "";
            for (int i = 0; i < path.Length - 3; i++)
            {
                pathNeed += path[i] + "\\";
            }
            var configuration = new ConfigurationBuilder()
                .SetBasePath(Directory.GetCurrentDirectory())
                .AddJsonFile(path: $"{pathNeed}appsettings.json", optional: false, reloadOnChange: true)
                .Build();
            services.AddSingleton<FormLainerCollection>().AddLogging(option =>
            {
                services.AddSingleton<FormLainerCollection>();
                var serilogLogger = new LoggerConfiguration()
                .ReadFrom.Configuration(configuration)
                .CreateLogger();
                services.AddLogging(x =>
                {
                    x.SetMinimumLevel(LogLevel.Debug);
                    x.AddSerilog(logger: serilogLogger, dispose: true);
                });
                
            });
        }
    }
}